<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use Carbon\Carbon;
use Illuminate\Database\Capsule\Manager;
use Illuminate\Support\Facades\DB;

class KapalModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "kapal";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "kapal";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "kodeKapal", "namaKapal", "date_updated"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "kapal.id",
        "kodeKapal" => "kapal.kodeKapal",
        "namaKapal" => "kapal.namaKapal",
    ];

    /**
     * relation from ' . pemakaianstok . ' by ' . kapalId
     * join pemakaianstok on pemakaianstok.id = kapal.kapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPemakaianstokKapalId($alias = "pemakaianstok")
    {
        $this->getQuery()->join("pemakaianstok as $alias", "$alias.kapalId", "=", "kapal.id");
        return $this;
    }

    /**
     * relation from ' . penerimaanbarang . ' by ' . kapalId
     * join penerimaanbarang on penerimaanbarang.id = kapal.kapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPenerimaanbarangKapalId($alias = "penerimaanbarang")
    {
        $this->getQuery()->join("penerimaanbarang as $alias", "$alias.kapalId", "=", "kapal.id");
        return $this;
    }

    /**
     * relation from ' . penyesuaianstok . ' by ' . kapalId
     * join penyesuaianstok on penyesuaianstok.id = kapal.kapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPenyesuaianstokKapalId($alias = "penyesuaianstok")
    {
        $this->getQuery()->join("penyesuaianstok as $alias", "$alias.kapalId", "=", "kapal.id");
        return $this;
    }

    /**
     * relation from ' . permintaanbarang . ' by ' . kapalId
     * join permintaanbarang on permintaanbarang.id = kapal.kapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPermintaanbarangKapalId($alias = "permintaanbarang")
    {
        $this->getQuery()->join("permintaanbarang as $alias", "$alias.kapalId", "=", "kapal.id");
        return $this;
    }

    /**
     * relation from ' . pindahstok . ' by ' . fromKapalId
     * join pindahstok on pindahstok.id = kapal.fromKapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPindahstokFromKapalId($alias = "pindahstok")
    {
        $this->getQuery()->join("pindahstok as $alias", "$alias.fromKapalId", "=", "kapal.id");
        return $this;
    }

    /**
     * relation from ' . pindahstok . ' by ' . toKapalId
     * join pindahstok on pindahstok.id = kapal.toKapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPindahstokToKapalId($alias = "pindahstok")
    {
        $this->getQuery()->join("pindahstok as $alias", "$alias.toKapalId", "=", "kapal.id");
        return $this;
    }

    /**
     * relation from ' . stokkapal . ' by ' . kapalId
     * join stokkapal on stokkapal.id = kapal.kapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationStokkapalKapalId($alias = "stokkapal")
    {
        $this->getQuery()->leftjoin("stokkapal as $alias", "$alias.kapalId", "=", "kapal.id");
        return $this;
    }

    /**
     * relation from ' . users . ' by ' . kapalId
     * join users on users.id = kapal.kapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationUsersKapalId($alias = "users")
    {
        $this->getQuery()->join("users as $alias", "$alias.kapalId", "=", "kapal.id");
        return $this;
    }

    public function syncErrorFromOracleHO($kapalID, $fromCMS = false)
    {
        echo "start sync recovery kapal data from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Sync Recovery Master Kapal", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getSyncErrorOracleQuery($kapalID))->execute();
        $rows = $oracleOCI->fetchAll(); $return = false;
        if($rows) {
            $item = new self();
            $return = $item->storingDataFromOracle($rows, $fromCMS);
        } else {
            $return = false;
        }
        (new LogsyncoracleModel)->setLogSync("Sync Recovery Master Kapal", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
        return $return;
    }

    public function syncFromOracleHO($syncTable, $fromCMS = false)
    {
        echo "start sync kapal data from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Master Kapal", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();
        $lastUpdate = $syncTable->last_sync;
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows, $fromCMS);
            if (!empty($rows->LAST_UPDATE_DATE)) $lastUpdate = $rows->LAST_UPDATE_DATE;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
        }
        (new LogsyncoracleModel)->setLogSync("Master Kapal", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
    }

    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = "SELECT IOV.*
                    FROM pelni_scm_io_v IOV
                    WHERE IOV.LAST_UPDATE_DATE >= TO_DATE('" . Carbon::parse($staging->last_sync)->toDateTimeString() . "', 'yyyy-mm-dd HH24:MI:SS')
                    ORDER BY IOV.LAST_UPDATE_DATE ASC";
        return $query;
    }

    public static function getSyncErrorOracleQuery($kapalID)
    {
        return "SELECT IOV.* FROM pelni_scm_io_v IOV WHERE IOV.MTL_IO_CODE = '" . $kapalID . "'";
    }

    public function mapperOracle($oracle)
    {
        $this->id = $oracle->MTL_IO;
        $this->kodeKapal = $oracle->MTL_IO_CODE;
        $this->namaKapal = $oracle->KAPAL;
        $this->date_updated = $oracle->LAST_UPDATE_DATE;
    }

    public function storingDataFromOracle($oracle, $fromCMS = false)
    {
        $itemExist = $this->getQuery()->where("kapal.id", "=", $oracle->MTL_IO)->first();
        if($fromCMS) { DB::beginTransaction(); } else { Manager::beginTransaction(); } // DB::beginTransaction();
        if ($itemExist) {
            $model = self::find($itemExist->id);
            $model->mapperOracle($oracle);
            try {
                $model->update();
                if($fromCMS) { DB::commit(); } else { Manager::commit(); }
                echo $model->namaKapal . " updated ", PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master Kapal : ".$oracle->MTL_IO. " - ".$oracle->MTL_IO_CODE." - ".$oracle->KAPAL , Carbon::now()->toDateTimeString(), "", "updated");
                return true;
            } catch (\Exception $exception) {
                if($fromCMS) { DB::rollBack(); } else { Manager::rollBack(); } // DB::rollBack();
                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master Kapal : ".$oracle->MTL_IO. " - ".$oracle->MTL_IO_CODE." - ".$oracle->KAPAL , Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        } else {
            try {
                $model = new self();
                $model->mapperOracle($oracle);
                $model->save();
                if($fromCMS) { DB::commit(); } else { Manager::commit(); }
                echo $model->namaKapal . " inserted ", PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master Kapal : ".$oracle->MTL_IO. " - ".$oracle->MTL_IO_CODE." - ".$oracle->KAPAL , Carbon::now()->toDateTimeString(), "", "inserted");
                return true;
            } catch (\Exception $exception) {
                if($fromCMS) { DB::rollBack(); } else { Manager::rollBack(); }
                // FUNCTION TO INSERT INTO SYNCERROR TABLE IN CASE THE PROCESS ABOVE HAS SOME ERROR
                $params = json_encode([
                    "MTL_IO_CODE" => $oracle->MTL_IO_CODE
                ] );
                $data = json_encode($oracle);
                (new SyncerrorModel)->saveError("pelni_scm_io_v", $params, $data, "HO");

                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master Kapal : ".$oracle->MTL_IO. " - ".$oracle->MTL_IO_CODE." - ".$oracle->KAPAL , Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        }
    }

    public static function storeFromHO($data)
    {
        $model = (new self())->getQuery()->where("kapal.id", "=", $data->id)->first();
        if ($model) {
            $model = self::find($model->id);
            $model->id = $data->id;            
            $model->kodeKapal = $data->kodeKapal;
            $model->namaKapal = $data->namaKapal;
            $model->date_updated = $data->date_updated;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Data kapal [IO] - ".$data->id." - ".$data->kodeKapal." - ". $data->namaKapal  , Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
            $model->id = $data->id;
            $model->kodeKapal = $data->kodeKapal;
            $model->namaKapal = $data->namaKapal;
            $model->date_updated = $data->date_updated;
            $model->save([], $data->id, 0);
            (new LogsynckapalModel)->setLogSync("Data kapal [IO] - ".$data->id." - ".$data->kodeKapal." - ". $data->namaKapal  , Carbon::now()->toDateTimeString(), "", "inserted");
        }
        echo $data->namaKapal . " sync", PHP_EOL;
    }

    public static function getKapal()
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_kapal";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 2)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Kapal HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $url = $url . "?date_updated=" . $lastUpdate . "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\KapalModel::storeFromHO($item);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else {
                        $fetch = false;
                    }

                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Kapal HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Kapal HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }
}